diff --git src/video/cocoa/SDL_cocoaopengl.m src/video/cocoa/SDL_cocoaopengl.m
index ffc59e671..da161ac9a 100644
--- src/video/cocoa/SDL_cocoaopengl.m
+++ src/video/cocoa/SDL_cocoaopengl.m
@@ -62,6 +62,7 @@ SDL_OpenGLAsyncDispatchChanged(void *userdata, const char *name, const char *old
     SDL_opengl_async_dispatch = SDL_GetStringBoolean(hint, SDL_FALSE);
 }
 
+#if defined(__clang__) /* legacy GCC builds vsync via NSOpenGLCPSwapInterval instead, see below */
 static CVReturn DisplayLinkCallback(CVDisplayLinkRef displayLink, const CVTimeStamp* now, const CVTimeStamp* outputTime, CVOptionFlags flagsIn, CVOptionFlags* flagsOut, void* displayLinkContext)
 {
     SDLOpenGLContext *nscontext = (__bridge SDLOpenGLContext *) displayLinkContext;
@@ -77,9 +78,12 @@ static CVReturn DisplayLinkCallback(CVDisplayLinkRef displayLink, const CVTimeSt
 
     return kCVReturnSuccess;
 }
+#endif /* __clang__ */
 
 @implementation SDLOpenGLContext : NSOpenGLContext
 
+@synthesize openglPixelFormat = _openglPixelFormat;
+
 - (id)initWithFormat:(NSOpenGLPixelFormat *)format
         shareContext:(NSOpenGLContext *)share
 {
@@ -93,14 +97,20 @@ static CVReturn DisplayLinkCallback(CVDisplayLinkRef displayLink, const CVTimeSt
         self->swapIntervalCond = SDL_CreateCond();
         self->swapIntervalMutex = SDL_CreateMutex();
         if (!self->swapIntervalCond || !self->swapIntervalMutex) {
+            SDL_COCOA_RELEASE(self);
             return nil;
         }
 
+#if defined(__clang__)
         /* !!! FIXME: check return values. */
         CVDisplayLinkCreateWithActiveCGDisplays(&self->displayLink);
         CVDisplayLinkSetOutputCallback(self->displayLink, &DisplayLinkCallback, (__bridge void * _Nullable) self);
         CVDisplayLinkSetCurrentCGDisplayFromOpenGLContext(self->displayLink, [self CGLContextObj], [format CGLPixelFormatObj]);
         CVDisplayLinkStart(displayLink);
+#endif
+        /* legacy GCC builds don't use the display link: NSOpenGLCPSwapInterval
+           still works before macOS 10.14, and CoreVideo may not on the OS
+           builds that need FORCE_OLD_API */
     }
 
     SDL_AddHintCallback(SDL_HINT_MAC_OPENGL_ASYNC_DISPATCH, SDL_OpenGLAsyncDispatchChanged, NULL);
@@ -122,7 +132,24 @@ static CVReturn DisplayLinkCallback(CVDisplayLinkRef displayLink, const CVTimeSt
 /* This should only be called on the thread on which a user is using the context. */
 - (void)updateIfNeeded
 {
-    const int value = SDL_AtomicSet(&self->dirty, 0);
+    int value;
+
+#if !defined(__clang__)
+    /* Complete a view attach that setWindow: deferred (old OS X logs
+       "invalid drawable" if it happens while the window has no backing
+       surface).  This runs on every MakeCurrent and buffer swap, so the
+       attach completes as soon as the window is on screen. */
+    if (self->window) {
+        SDL_WindowData *windowdata = (__bridge SDL_WindowData *)self->window->driverdata;
+        NSView *contentview = windowdata.sdlContentView;
+        if (([self view] != contentview) && [windowdata.nswindow isVisible]) {
+            [self setView:contentview];
+            [self scheduleUpdate];
+        }
+    }
+#endif
+
+    value = SDL_AtomicSet(&self->dirty, 0);
     if (value > 0) {
         /* We call the real underlying update here, since -[SDLOpenGLContext update] just calls us. */
         [self explicitUpdate];
@@ -163,10 +190,27 @@ static CVReturn DisplayLinkCallback(CVDisplayLinkRef displayLink, const CVTimeSt
         }
 
         if ([self view] != contentview) {
+#if !defined(__clang__)
+            /* Attaching to a window with no backing surface yet makes old
+               OS X log "invalid drawable" to the terminal; defer the attach
+               to updateIfNeeded until the window is on screen.  (The context
+               is already registered in nscontexts above.) */
+            if (![windowdata.nswindow isVisible]) {
+                return;
+            }
+#endif
             if ([NSThread isMainThread]) {
                 [self setView:contentview];
             } else {
+#if defined(__clang__)
                 dispatch_sync(dispatch_get_main_queue(), ^{ [self setView:contentview]; });
+#else
+                /* Call directly, like SDL <= 2.0.9 always did: the era of
+                   AppKit that GCC builds target tolerates this off the main
+                   thread, and the main thread may not be running a runloop
+                   to service a marshalled call (e.g. mpv's vo thread). */
+                [self setView:contentview];
+#endif
             }
             if (self == [NSOpenGLContext currentContext]) {
                 [self explicitUpdate];
@@ -178,7 +222,11 @@ static CVReturn DisplayLinkCallback(CVDisplayLinkRef displayLink, const CVTimeSt
         if ([NSThread isMainThread]) {
             [self setView:nil];
         } else {
+#if defined(__clang__)
             dispatch_sync(dispatch_get_main_queue(), ^{ [self setView:nil]; });
+#else
+            [self setView:nil]; /* see the comment in the branch above */
+#endif
         }
     }
 }
@@ -193,17 +241,22 @@ static CVReturn DisplayLinkCallback(CVDisplayLinkRef displayLink, const CVTimeSt
     if ([NSThread isMainThread]) {
         [super update];
     } else {
+#if defined(__clang__)
         if (SDL_opengl_async_dispatch) {
             dispatch_async(dispatch_get_main_queue(), ^{ [super update]; });
         } else {
             dispatch_sync(dispatch_get_main_queue(), ^{ [super update]; });
         }
+#else
+        [super update]; /* see the comment in -setWindow: */
+#endif
     }
 }
 
 - (void)cleanup
 {
     [self setWindow:NULL];
+    self.openglPixelFormat = nil;
 
     SDL_DelHintCallback(SDL_HINT_MAC_OPENGL_ASYNC_DISPATCH, SDL_OpenGLAsyncDispatchChanged, NULL);
     if (self->displayLink) {
@@ -253,7 +306,7 @@ void Cocoa_GL_UnloadLibrary(_THIS)
 }
 
 SDL_GLContext Cocoa_GL_CreateContext(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoDisplay *display = SDL_GetDisplayForWindow(window);
     SDL_DisplayData *displaydata = (SDL_DisplayData *)display->driverdata;
@@ -267,7 +320,11 @@ SDL_GLContext Cocoa_GL_CreateContext(_THIS, SDL_Window * window)
     int glversion_major;
     int glversion_minor;
     NSOpenGLPixelFormatAttribute profile;
+#if defined(__clang__)
     int interval;
+#else
+    long interval; /* -[NSOpenGLContext setValues:forParameter:] takes const long * on old SDKs */
+#endif
 
     if (_this->gl_config.profile_mask == SDL_GL_CONTEXT_PROFILE_ES) {
 #ifdef SDL_VIDEO_OPENGL_EGL
@@ -295,12 +352,20 @@ SDL_GLContext Cocoa_GL_CreateContext(_THIS, SDL_Window * window)
 
     attr[i++] = NSOpenGLPFAAllowOfflineRenderers;
 
+#ifdef MAC_OS_X_VERSION_10_7 /* NSOpenGLPFAOpenGLProfile arrived with the 10.7 SDK */
     profile = NSOpenGLProfileVersionLegacy;
     if (_this->gl_config.profile_mask == SDL_GL_CONTEXT_PROFILE_CORE) {
         profile = NSOpenGLProfileVersion3_2Core;
     }
     attr[i++] = NSOpenGLPFAOpenGLProfile;
     attr[i++] = profile;
+#else
+    (void) profile;
+    if (_this->gl_config.profile_mask == SDL_GL_CONTEXT_PROFILE_CORE) {
+        SDL_SetError("OpenGL core profiles are not supported before Mac OS X 10.7");
+        return NULL;
+    }
+#endif
 
     attr[i++] = NSOpenGLPFAColorSize;
     attr[i++] = SDL_BYTESPERPIXEL(display->current_mode.format)*8;
@@ -356,7 +421,7 @@ SDL_GLContext Cocoa_GL_CreateContext(_THIS, SDL_Window * window)
     attr[i++] = CGDisplayIDToOpenGLDisplayMask(displaydata->display);
     attr[i] = 0;
 
-    fmt = [[NSOpenGLPixelFormat alloc] initWithAttributes:attr];
+    fmt = SDL_COCOA_AUTORELEASE([[NSOpenGLPixelFormat alloc] initWithAttributes:attr]);
     if (fmt == nil) {
         SDL_SetError("Failed creating OpenGL pixel format");
         return NULL;
@@ -373,9 +438,11 @@ SDL_GLContext Cocoa_GL_CreateContext(_THIS, SDL_Window * window)
         return NULL;
     }
 
-    sdlcontext = (SDL_GLContext)CFBridgingRetain(context);
+    sdlcontext = (SDL_GLContext)SDL_CFBridgingRetain(context);
+    SDL_COCOA_RELEASE(context); /* the sdlcontext reference keeps it alive */
 
-    /* vsync is handled separately by synchronizing with a display link. */
+    /* vsync is handled separately by synchronizing with a display link
+       (or via this parameter in SetSwapInterval on legacy GCC builds). */
     interval = 0;
     [context setValues:&interval forParameter:NSOpenGLCPSwapInterval];
 
@@ -429,7 +496,7 @@ SDL_GLContext Cocoa_GL_CreateContext(_THIS, SDL_Window * window)
 }}
 
 int Cocoa_GL_MakeCurrent(_THIS, SDL_Window * window, SDL_GLContext context)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     if (context) {
         SDLOpenGLContext *nscontext = (__bridge SDLOpenGLContext *)context;
@@ -446,7 +513,7 @@ int Cocoa_GL_MakeCurrent(_THIS, SDL_Window * window, SDL_GLContext context)
 }}
 
 int Cocoa_GL_SetSwapInterval(_THIS, int interval)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDLOpenGLContext *nscontext = (__bridge SDLOpenGLContext *) SDL_GL_GetCurrentContext();
     int status;
@@ -458,6 +525,15 @@ int Cocoa_GL_SetSwapInterval(_THIS, int interval)
         SDL_AtomicSet(&nscontext->swapIntervalsPassed, 0);
         SDL_AtomicSet(&nscontext->swapIntervalSetting, interval);
         SDL_UnlockMutex(nscontext->swapIntervalMutex);
+#if !defined(__clang__)
+        {
+            /* Legacy GCC builds vsync via the context parameter, as SDL
+               <= 2.0.9 did (no adaptive vsync this way).  The parameter
+               takes a const long * on old SDKs. */
+            long value = (interval < 0) ? 1 : interval;
+            [nscontext setValues:&value forParameter:NSOpenGLCPSwapInterval];
+        }
+#endif
         status = 0;
     }
 
@@ -465,17 +541,18 @@ int Cocoa_GL_SetSwapInterval(_THIS, int interval)
 }}
 
 int Cocoa_GL_GetSwapInterval(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDLOpenGLContext* nscontext = (__bridge SDLOpenGLContext*)SDL_GL_GetCurrentContext();
     return nscontext ? SDL_AtomicGet(&nscontext->swapIntervalSetting) : 0;
 }}
 
 int Cocoa_GL_SwapWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDLOpenGLContext* nscontext = (__bridge SDLOpenGLContext*)SDL_GL_GetCurrentContext();
     SDL_VideoData *videodata = (__bridge SDL_VideoData *) _this->driverdata;
+#if defined(__clang__) /* legacy GCC builds vsync via NSOpenGLCPSwapInterval instead */
     const int setting = SDL_AtomicGet(&nscontext->swapIntervalSetting);
 
     if (setting == 0) {
@@ -495,6 +572,7 @@ int Cocoa_GL_SwapWindow(_THIS, SDL_Window * window)
         SDL_AtomicSet(&nscontext->swapIntervalsPassed, 0);
         SDL_UnlockMutex(nscontext->swapIntervalMutex);
     }
+#endif /* __clang__ */
 
     /*{ static Uint64 prev = 0; const Uint64 now = SDL_GetTicks64(); const unsigned int diff = (unsigned int) (now - prev); prev = now; printf("GLSWAPBUFFERS TICKS %u\n", diff); }*/
 
@@ -509,7 +587,7 @@ int Cocoa_GL_SwapWindow(_THIS, SDL_Window * window)
 
 static void DispatchedDeleteContext(SDL_GLContext context)
 {
-    @autoreleasepool {
+    SDL_COCOA_POOL {
         SDLOpenGLContext *nscontext = (__bridge SDLOpenGLContext *)context;
         [nscontext cleanup];
         CFRelease(context);
@@ -521,6 +599,7 @@ void Cocoa_GL_DeleteContext(_THIS, SDL_GLContext context)
     if ([NSThread isMainThread]) {
         DispatchedDeleteContext(context);
     } else {
+#if defined(__clang__)
         if (SDL_opengl_async_dispatch) {
             dispatch_async(dispatch_get_main_queue(), ^{
               DispatchedDeleteContext(context);
@@ -530,6 +609,9 @@ void Cocoa_GL_DeleteContext(_THIS, SDL_GLContext context)
               DispatchedDeleteContext(context);
             });
         }
+#else
+        DispatchedDeleteContext(context); /* see the comment in -setWindow: */
+#endif
     }
 }
 
diff --git src/video/cocoa/SDL_cocoaopengles.m src/video/cocoa/SDL_cocoaopengles.m
index 074646037..94bd6027c 100644
--- src/video/cocoa/SDL_cocoaopengles.m
+++ src/video/cocoa/SDL_cocoaopengles.m
@@ -57,7 +57,7 @@ int Cocoa_GLES_LoadLibrary(_THIS, const char *path)
 }
 
 SDL_GLContext Cocoa_GLES_CreateContext(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_GLContext context;
     SDL_WindowData *data = (__bridge SDL_WindowData *)window->driverdata;
@@ -89,19 +89,19 @@ SDL_GLContext Cocoa_GLES_CreateContext(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_GLES_DeleteContext(_THIS, SDL_GLContext context)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_EGL_DeleteContext(_this, context);
 }}
 
 int Cocoa_GLES_SwapWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     return SDL_EGL_SwapBuffers(_this, ((__bridge SDL_WindowData *) window->driverdata).egl_surface);
 }}
 
 int Cocoa_GLES_MakeCurrent(_THIS, SDL_Window * window, SDL_GLContext context)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     return SDL_EGL_MakeCurrent(_this, window ? ((__bridge SDL_WindowData *) window->driverdata).egl_surface : EGL_NO_SURFACE, context);
 }}
diff --git src/video/cocoa/SDL_cocoashape.h src/video/cocoa/SDL_cocoashape.h
index 82b8658b3..ed4c9cca4 100644
--- src/video/cocoa/SDL_cocoashape.h
+++ src/video/cocoa/SDL_cocoashape.h
@@ -30,7 +30,12 @@
 #include "../SDL_shape_internals.h"
 
 @interface SDL_ShapeData : NSObject
-    @property (nonatomic) NSGraphicsContext* context;
+{
+    NSGraphicsContext *_context;
+    SDL_bool _saved;
+    SDL_ShapeTree *_shape;
+}
+    @property (nonatomic, retain) NSGraphicsContext* context;
     @property (nonatomic) SDL_bool saved;
     @property (nonatomic) SDL_ShapeTree* shape;
 @end
diff --git src/video/cocoa/SDL_cocoashape.m src/video/cocoa/SDL_cocoashape.m
index e1421ee1b..1373a361b 100644
--- src/video/cocoa/SDL_cocoashape.m
+++ src/video/cocoa/SDL_cocoashape.m
@@ -28,19 +28,51 @@
 #include "../SDL_sysvideo.h"
 
 @implementation SDL_ShapeData
+
+@synthesize context = _context;
+@synthesize saved = _saved;
+@synthesize shape = _shape;
+
+#if !SDL_COCOA_ARC
+- (void)dealloc
+{
+    [_context release];
+    [super dealloc];
+}
+#endif
+
 @end
 
 @interface SDL_CocoaClosure : NSObject
-    @property (nonatomic) NSView* view;
-    @property (nonatomic) NSBezierPath* path;
+{
+    NSView *_view;
+    NSBezierPath *_path;
+    SDL_Window *_window;
+}
+    @property (nonatomic, retain) NSView* view;
+    @property (nonatomic, retain) NSBezierPath* path;
     @property (nonatomic) SDL_Window* window;
 @end
 
 @implementation SDL_CocoaClosure
+
+@synthesize view = _view;
+@synthesize path = _path;
+@synthesize window = _window;
+
+#if !SDL_COCOA_ARC
+- (void)dealloc
+{
+    [_view release];
+    [_path release];
+    [super dealloc];
+}
+#endif
+
 @end
 
 SDL_WindowShaper *Cocoa_CreateShaper(SDL_Window* window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowShaper* result;
     SDL_ShapeData* data;
@@ -55,7 +87,13 @@ SDL_WindowShaper *Cocoa_CreateShaper(SDL_Window* window)
 
     [windata.nswindow setOpaque:NO];
 
+#ifdef MAC_OS_X_VERSION_10_6
     [windata.nswindow setStyleMask:NSWindowStyleMaskBorderless];
+#else
+    if ([windata.nswindow respondsToSelector:@selector(setStyleMask:)]) {
+        [windata.nswindow performSelector:@selector(setStyleMask:) withObject:(id)(uintptr_t)NSWindowStyleMaskBorderless];
+    }
+#endif
 
     result->window = window;
     result->mode.mode = ShapeModeDefault;
@@ -69,7 +107,8 @@ SDL_WindowShaper *Cocoa_CreateShaper(SDL_Window* window)
     data.shape = NULL;
 
     /* TODO: There's no place to release this... */
-    result->driverdata = (void*) CFBridgingRetain(data);
+    result->driverdata = SDL_CFBridgingRetain(data);
+    SDL_COCOA_RELEASE(data); /* the driverdata reference keeps it alive */
 
     resized_properly = Cocoa_ResizeWindowShape(window);
     SDL_assert(resized_properly == 0);
@@ -86,7 +125,7 @@ static void ConvertRects(SDL_ShapeTree* tree, void* closure)
 }
 
 int Cocoa_SetWindowShape(SDL_WindowShaper *shaper, SDL_Surface *shape, SDL_WindowShapeMode *shape_mode)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_ShapeData* data = (__bridge SDL_ShapeData*)shaper->driverdata;
     SDL_WindowData* windata = (__bridge SDL_WindowData*)shaper->window->driverdata;
@@ -104,7 +143,7 @@ int Cocoa_SetWindowShape(SDL_WindowShaper *shaper, SDL_Surface *shape, SDL_Windo
     NSRectFill([windata.sdlContentView frame]);
     data.shape = SDL_CalculateShapeTree(*shape_mode, shape);
 
-    closure = [[SDL_CocoaClosure alloc] init];
+    closure = SDL_COCOA_AUTORELEASE([[SDL_CocoaClosure alloc] init]);
 
     closure.view = windata.sdlContentView;
     closure.path = [NSBezierPath bezierPath];
@@ -116,7 +155,7 @@ int Cocoa_SetWindowShape(SDL_WindowShaper *shaper, SDL_Surface *shape, SDL_Windo
 }}
 
 int Cocoa_ResizeWindowShape(SDL_Window *window)
-{ @autoreleasepool {
+{ SDL_COCOA_POOL {
     SDL_ShapeData* data = (__bridge SDL_ShapeData*)window->shaper->driverdata;
     SDL_assert(data != NULL);
     return 0;
diff --git src/video/cocoa/SDL_cocoavideo.h src/video/cocoa/SDL_cocoavideo.h
index d7663f90c..d159a0c1d 100644
--- src/video/cocoa/SDL_cocoavideo.h
+++ src/video/cocoa/SDL_cocoavideo.h
@@ -29,6 +29,8 @@
 #include <IOKit/pwr_mgt/IOPMLib.h>
 #include <Cocoa/Cocoa.h>
 
+#include "SDL_cocoacompat.h"
+
 #include "SDL_keycode.h"
 #include "../SDL_sysvideo.h"
 
@@ -41,56 +43,57 @@
 #include "SDL_cocoawindow.h"
 
 #ifndef MAC_OS_X_VERSION_10_12
-#define DECLARE_EVENT(name) static const NSEventType NSEventType##name = NS##name
-DECLARE_EVENT(LeftMouseDown);
-DECLARE_EVENT(LeftMouseUp);
-DECLARE_EVENT(RightMouseDown);
-DECLARE_EVENT(RightMouseUp);
-DECLARE_EVENT(OtherMouseDown);
-DECLARE_EVENT(OtherMouseUp);
-DECLARE_EVENT(MouseMoved);
-DECLARE_EVENT(LeftMouseDragged);
-DECLARE_EVENT(RightMouseDragged);
-DECLARE_EVENT(OtherMouseDragged);
-DECLARE_EVENT(ScrollWheel);
-DECLARE_EVENT(KeyDown);
-DECLARE_EVENT(KeyUp);
-DECLARE_EVENT(FlagsChanged);
-#undef DECLARE_EVENT
-
-static const NSEventMask NSEventMaskAny = NSAnyEventMask;
-
-#define DECLARE_MODIFIER_FLAG(name) static const NSUInteger NSEventModifierFlag##name = NS##name##KeyMask
-DECLARE_MODIFIER_FLAG(Shift);
-DECLARE_MODIFIER_FLAG(Control);
-DECLARE_MODIFIER_FLAG(Command);
-DECLARE_MODIFIER_FLAG(NumericPad);
-DECLARE_MODIFIER_FLAG(Help);
-DECLARE_MODIFIER_FLAG(Function);
-#undef DECLARE_MODIFIER_FLAG
-static const NSUInteger NSEventModifierFlagCapsLock = NSAlphaShiftKeyMask;
-static const NSUInteger NSEventModifierFlagOption = NSAlternateKeyMask;
-
-#define DECLARE_WINDOW_MASK(name) static const unsigned int NSWindowStyleMask##name = NS##name##WindowMask
-DECLARE_WINDOW_MASK(Borderless);
-DECLARE_WINDOW_MASK(Titled);
-DECLARE_WINDOW_MASK(Closable);
-DECLARE_WINDOW_MASK(Miniaturizable);
-DECLARE_WINDOW_MASK(Resizable);
-DECLARE_WINDOW_MASK(TexturedBackground);
-DECLARE_WINDOW_MASK(UnifiedTitleAndToolbar);
-DECLARE_WINDOW_MASK(FullScreen);
-/*DECLARE_WINDOW_MASK(FullSizeContentView);*/ /* Not used, fails compile on older SDKs */
-static const unsigned int NSWindowStyleMaskUtilityWindow = NSUtilityWindowMask;
-static const unsigned int NSWindowStyleMaskDocModalWindow = NSDocModalWindowMask;
-static const unsigned int NSWindowStyleMaskHUDWindow = NSHUDWindowMask;
-#undef DECLARE_WINDOW_MASK
-
-#define DECLARE_ALERT_STYLE(name) static const NSUInteger NSAlertStyle##name = NS##name##AlertStyle
-DECLARE_ALERT_STYLE(Warning);
-DECLARE_ALERT_STYLE(Informational);
-DECLARE_ALERT_STYLE(Critical);
-#undef DECLARE_ALERT_STYLE
+/* #defines rather than static consts: GCC does not accept const variables
+   as switch case labels, and these are used in event-type switches. */
+#define NSEventTypeLeftMouseDown NSLeftMouseDown
+#define NSEventTypeLeftMouseUp NSLeftMouseUp
+#define NSEventTypeRightMouseDown NSRightMouseDown
+#define NSEventTypeRightMouseUp NSRightMouseUp
+#define NSEventTypeOtherMouseDown NSOtherMouseDown
+#define NSEventTypeOtherMouseUp NSOtherMouseUp
+#define NSEventTypeMouseMoved NSMouseMoved
+#define NSEventTypeLeftMouseDragged NSLeftMouseDragged
+#define NSEventTypeRightMouseDragged NSRightMouseDragged
+#define NSEventTypeOtherMouseDragged NSOtherMouseDragged
+#define NSEventTypeScrollWheel NSScrollWheel
+#define NSEventTypeKeyDown NSKeyDown
+#define NSEventTypeKeyUp NSKeyUp
+#define NSEventTypeFlagsChanged NSFlagsChanged
+
+/* Pre-10.12 SDKs do not all have the NSEventMask typedef */
+#define NSEventMaskAny NSAnyEventMask
+
+#define NSEventModifierFlagShift NSShiftKeyMask
+#define NSEventModifierFlagControl NSControlKeyMask
+#define NSEventModifierFlagCommand NSCommandKeyMask
+#define NSEventModifierFlagNumericPad NSNumericPadKeyMask
+#define NSEventModifierFlagHelp NSHelpKeyMask
+#define NSEventModifierFlagFunction NSFunctionKeyMask
+#define NSEventModifierFlagCapsLock NSAlphaShiftKeyMask
+#define NSEventModifierFlagOption NSAlternateKeyMask
+
+#define NSWindowStyleMaskBorderless NSBorderlessWindowMask
+#define NSWindowStyleMaskTitled NSTitledWindowMask
+#define NSWindowStyleMaskClosable NSClosableWindowMask
+#define NSWindowStyleMaskMiniaturizable NSMiniaturizableWindowMask
+#define NSWindowStyleMaskResizable NSResizableWindowMask
+#define NSWindowStyleMaskTexturedBackground NSTexturedBackgroundWindowMask
+#define NSWindowStyleMaskUnifiedTitleAndToolbar NSUnifiedTitleAndToolbarWindowMask
+#ifdef MAC_OS_X_VERSION_10_7 /* NSFullScreenWindowMask first appeared in the 10.7 SDK */
+#define NSWindowStyleMaskFullScreen NSFullScreenWindowMask
+#else
+#define NSWindowStyleMaskFullScreen (1 << 14)
+#endif
+/* NSWindowStyleMaskFullSizeContentView not provided; unused, fails compile on older SDKs */
+#define NSWindowStyleMaskUtilityWindow NSUtilityWindowMask
+#define NSWindowStyleMaskDocModalWindow NSDocModalWindowMask
+#ifdef MAC_OS_X_VERSION_10_6 /* NSHUDWindowMask first appeared in the 10.6 SDK */
+#define NSWindowStyleMaskHUDWindow NSHUDWindowMask
+#endif
+
+#define NSAlertStyleWarning NSWarningAlertStyle
+#define NSAlertStyleInformational NSInformationalAlertStyle
+#define NSAlertStyleCritical NSCriticalAlertStyle
 #endif
 
 /* Private display data */
@@ -98,11 +101,23 @@ DECLARE_ALERT_STYLE(Critical);
 @class SDLTranslatorResponder;
 
 @interface SDL_VideoData : NSObject
+{
+    /* Explicit ivars: synthesized ivars are unavailable with the fragile
+       Objective-C ABI (32-bit Mac OS X) and with GCC. */
+    int _allow_spaces;
+    int _trackpad_is_touch_only;
+    unsigned int _modifierFlags;
+    void *_key_layout;
+    SDLTranslatorResponder *_fieldEdit;
+    NSInteger _clipboard_count;
+    IOPMAssertionID _screensaver_assertion;
+    SDL_mutex *_swaplock;
+}
     @property (nonatomic) int allow_spaces;
     @property (nonatomic) int trackpad_is_touch_only;
     @property (nonatomic) unsigned int modifierFlags;
     @property (nonatomic) void *key_layout;
-    @property (nonatomic) SDLTranslatorResponder *fieldEdit;
+    @property (nonatomic, retain) SDLTranslatorResponder *fieldEdit;
     @property (nonatomic) NSInteger clipboard_count;
     @property (nonatomic) IOPMAssertionID screensaver_assertion;
     @property (nonatomic) SDL_mutex *swaplock;
diff --git src/video/cocoa/SDL_cocoavideo.m src/video/cocoa/SDL_cocoavideo.m
index 4ca68ba83..02d823515 100644
--- src/video/cocoa/SDL_cocoavideo.m
+++ src/video/cocoa/SDL_cocoavideo.m
@@ -22,10 +22,6 @@
 
 #ifdef SDL_VIDEO_DRIVER_COCOA
 
-#if !__has_feature(objc_arc)
-#error SDL must be built with Objective-C ARC (automatic reference counting) enabled
-#endif
-
 #include "SDL.h"
 #include "SDL_endian.h"
 #include "SDL_cocoavideo.h"
@@ -35,8 +31,31 @@
 #include "SDL_cocoaopengles.h"
 #include "SDL_cocoamessagebox.h"
 
+/* ARC is expected with clang on the modern (non-fragile) Objective-C runtime;
+   GCC and 32-bit fragile-runtime builds use manual retain/release instead. */
+#if defined(__clang__) && defined(__OBJC2__) && !SDL_COCOA_ARC
+#error SDL must be built with Objective-C ARC (automatic reference counting) enabled
+#endif
+
 @implementation SDL_VideoData
 
+@synthesize allow_spaces = _allow_spaces;
+@synthesize trackpad_is_touch_only = _trackpad_is_touch_only;
+@synthesize modifierFlags = _modifierFlags;
+@synthesize key_layout = _key_layout;
+@synthesize fieldEdit = _fieldEdit;
+@synthesize clipboard_count = _clipboard_count;
+@synthesize screensaver_assertion = _screensaver_assertion;
+@synthesize swaplock = _swaplock;
+
+#if !SDL_COCOA_ARC
+- (void)dealloc
+{
+    [_fieldEdit release];
+    [super dealloc];
+}
+#endif
+
 @end
 
 /* Initialization/Query functions */
@@ -46,14 +65,14 @@ static void Cocoa_VideoQuit(_THIS);
 /* Cocoa driver bootstrap functions */
 
 static void Cocoa_DeleteDevice(SDL_VideoDevice * device)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
-    CFBridgingRelease(device->driverdata);
+    (void) SDL_CFBridgingRelease(device->driverdata);
     SDL_free(device);
 }}
 
 static SDL_VideoDevice *Cocoa_CreateDevice(void)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoDevice *device;
     SDL_VideoData *data;
@@ -72,7 +91,8 @@ static SDL_VideoDevice *Cocoa_CreateDevice(void)
         SDL_free(device);
         return NULL;
     }
-    device->driverdata = (void *)CFBridgingRetain(data);
+    device->driverdata = SDL_CFBridgingRetain(data);
+    SDL_COCOA_RELEASE(data); /* the driverdata reference keeps it alive */
 
     /* Set the function pointers */
     device->VideoInit = Cocoa_VideoInit;
@@ -182,7 +202,7 @@ VideoBootStrap COCOA_bootstrap = {
 
 
 int Cocoa_VideoInit(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoData *data = (__bridge SDL_VideoData *) _this->driverdata;
 
@@ -192,7 +212,12 @@ int Cocoa_VideoInit(_THIS)
         return -1;
     }
 
-    data.allow_spaces = SDL_GetHintBoolean(SDL_HINT_VIDEO_MAC_FULLSCREEN_SPACES, SDL_TRUE);
+#ifdef MAC_OS_X_VERSION_10_7
+    data.allow_spaces = SDL_GetHintBoolean(SDL_HINT_VIDEO_MAC_FULLSCREEN_SPACES, SDL_TRUE) &&
+                        (floor(NSAppKitVersionNumber) >= NSAppKitVersionNumber10_7);
+#else
+    data.allow_spaces = 0; /* fullscreen Spaces need 10.7+ */
+#endif
     data.trackpad_is_touch_only = SDL_GetHintBoolean(SDL_HINT_TRACKPAD_IS_TOUCH_ONLY, SDL_FALSE);
 
     data.swaplock = SDL_CreateMutex();
@@ -204,7 +229,7 @@ int Cocoa_VideoInit(_THIS)
 }}
 
 void Cocoa_VideoQuit(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoData *data = (__bridge SDL_VideoData *) _this->driverdata;
     Cocoa_QuitModes(_this);
@@ -228,7 +253,7 @@ NSImage *Cocoa_CreateImage(SDL_Surface * surface)
         return nil;
     }
 
-    imgrep = [[NSBitmapImageRep alloc] initWithBitmapDataPlanes: NULL
+    imgrep = SDL_COCOA_AUTORELEASE([[NSBitmapImageRep alloc] initWithBitmapDataPlanes: NULL
                     pixelsWide: converted->w
                     pixelsHigh: converted->h
                     bitsPerSample: 8
@@ -237,7 +262,7 @@ NSImage *Cocoa_CreateImage(SDL_Surface * surface)
                     isPlanar: NO
                     colorSpaceName: NSDeviceRGBColorSpace
                     bytesPerRow: converted->pitch
-                    bitsPerPixel: converted->format->BitsPerPixel];
+                    bitsPerPixel: converted->format->BitsPerPixel]);
     if (imgrep == nil) {
         SDL_FreeSurface(converted);
         return nil;
@@ -257,7 +282,7 @@ NSImage *Cocoa_CreateImage(SDL_Surface * surface)
         pixels += 4;
     }
 
-    img = [[NSImage alloc] initWithSize: NSMakeSize(surface->w, surface->h)];
+    img = SDL_COCOA_AUTORELEASE([[NSImage alloc] initWithSize: NSMakeSize(surface->w, surface->h)]);
     if (img != nil) {
         [img addRepresentation: imgrep];
     }
@@ -276,7 +301,7 @@ NSImage *Cocoa_CreateImage(SDL_Surface * surface)
 
 void SDL_NSLog(const char *prefix, const char *text)
 {
-    @autoreleasepool {
+    SDL_COCOA_POOL {
         NSString *nsText = [NSString stringWithUTF8String:text];
         if (prefix) {
             NSString *nsPrefix = [NSString stringWithUTF8String:prefix];
diff --git src/video/cocoa/SDL_cocoawindow.h src/video/cocoa/SDL_cocoawindow.h
index 7ef0bc036..324c4b54e 100644
--- src/video/cocoa/SDL_cocoawindow.h
+++ src/video/cocoa/SDL_cocoawindow.h
@@ -25,6 +25,8 @@
 
 #import <Cocoa/Cocoa.h>
 
+#include "SDL_cocoacompat.h"
+
 #ifdef SDL_VIDEO_OPENGL_EGL
 #include "../SDL_egl_c.h"
 #endif
@@ -39,11 +41,15 @@ typedef enum
     PENDING_OPERATION_MINIMIZE
 } PendingWindowOperation;
 
+#ifdef MAC_OS_X_VERSION_10_6 /* delegate protocols were introduced with the 10.6 SDK */
 @interface Cocoa_WindowListener : NSResponder <NSWindowDelegate> {
+#else
+@interface Cocoa_WindowListener : NSResponder {
+#endif
     /* SDL_WindowData owns this Listener and has a strong reference to it.
      * To avoid reference cycles, we could have either a weak or an
      * unretained ref to the WindowData. */
-    __weak SDL_WindowData *_data;
+    SDL_COCOA_WEAK SDL_WindowData *_data;
     BOOL observingVisible;
     BOOL wasCtrlLeft;
     BOOL wasVisible;
@@ -94,7 +100,9 @@ typedef enum
 -(void) windowDidEnterFullScreen:(NSNotification *) aNotification;
 -(void) windowWillExitFullScreen:(NSNotification *) aNotification;
 -(void) windowDidExitFullScreen:(NSNotification *) aNotification;
+#ifdef MAC_OS_X_VERSION_10_7 /* fullscreen presentation options arrived with the 10.7 SDK */
 -(NSApplicationPresentationOptions)window:(NSWindow *)window willUseFullScreenPresentationOptions:(NSApplicationPresentationOptions)proposedOptions;
+#endif
 
 /* See if event is in a drag area, toggle on window dragging. */
 -(BOOL) processHitTest:(NSEvent *)theEvent;
@@ -111,6 +119,7 @@ typedef enum
 -(void) rightMouseDragged:(NSEvent *) theEvent;
 -(void) otherMouseDragged:(NSEvent *) theEvent;
 -(void) scrollWheel:(NSEvent *) theEvent;
+#ifdef MAC_OS_X_VERSION_10_6 /* NSTouch and friends arrived with the 10.6 SDK */
 -(void) touchesBeganWithEvent:(NSEvent *) theEvent;
 -(void) touchesMovedWithEvent:(NSEvent *) theEvent;
 -(void) touchesEndedWithEvent:(NSEvent *) theEvent;
@@ -118,6 +127,7 @@ typedef enum
 
 /* Touch event handling */
 -(void) handleTouches:(NSTouchPhase) phase withEvent:(NSEvent*) theEvent;
+#endif
 
 @end
 /* *INDENT-ON* */
@@ -126,16 +136,33 @@ typedef enum
 @class SDL_VideoData;
 
 @interface SDL_WindowData : NSObject
+{
+    /* Explicit ivars: synthesized ivars are unavailable with the fragile
+       Objective-C ABI (32-bit Mac OS X) and with GCC. */
+    SDL_Window *_window;
+    NSWindow *_nswindow;
+    NSView *_sdlContentView;
+    NSMutableArray *_nscontexts;
+    SDL_bool _created;
+    SDL_bool _inWindowFullscreenTransition;
+    NSInteger _window_number;
+    NSInteger _flash_request;
+    Cocoa_WindowListener *_listener;
+    SDL_VideoData *_videodata;
+#ifdef SDL_VIDEO_OPENGL_EGL
+    EGLSurface _egl_surface;
+#endif
+}
     @property (nonatomic) SDL_Window *window;
-    @property (nonatomic) NSWindow *nswindow;
-    @property (nonatomic) NSView *sdlContentView;
-    @property (nonatomic) NSMutableArray *nscontexts;
+    @property (nonatomic, retain) NSWindow *nswindow;
+    @property (nonatomic, retain) NSView *sdlContentView;
+    @property (nonatomic, retain) NSMutableArray *nscontexts;
     @property (nonatomic) SDL_bool created;
     @property (nonatomic) SDL_bool inWindowFullscreenTransition;
     @property (nonatomic) NSInteger window_number;
     @property (nonatomic) NSInteger flash_request;
-    @property (nonatomic) Cocoa_WindowListener *listener;
-    @property (nonatomic) SDL_VideoData *videodata;
+    @property (nonatomic, retain) Cocoa_WindowListener *listener;
+    @property (nonatomic, retain) SDL_VideoData *videodata;
 #ifdef SDL_VIDEO_OPENGL_EGL
     @property (nonatomic) EGLSurface egl_surface;
 #endif
